\chapter{Discussion}
\label{cap:discuss}

Not every thing planned has been accomplished, none was discovered, but much was \textit{learned}. Following are the main takeaways from this project.

\section{Results and analysis}
\label{sec:discuss_done}

\begin{enumerate}
    \item data augmentation works, as proven in \ref{sec:toy_task-small-experiments_augm}
    \item the training process must follow \href{http://karpathy.github.io/2019/04/25/recipe/}{heuristics}, especially when the choice of optimizer and optimizer parameters is due (see \ref{sec:toy_task-small-experiments_optim})
    \item Occam's razor applies to machine learning: the vanilla U-Net out-performs (even its attention-based competitors) all the time (see \ref{sec:toy_task-experiments})
\end{enumerate}

\section{Questions for the future}
\label{sec:discuss_todo}

\begin{enumerate}
    \item why replacing embedding is so difficult (see \ref{sec:igpt_Manual_embeddings})? Is there something wrong in the implementation?
    \item more in general, how can the output of a NN be debugged (at runtime): if we are really near \href{https://medium.com/@karpathy/software-2-0-a64152b37c35}{Software 2.0} then we must develop tools to handle it
    \item do representations get learned? From \cite{paper:igpt_segm}'s work, it seems so. Can they be learned in the context of segmentation of the datasets at hand?
    \item how robust is the output of a trained iGPT? Could it \href{https://arxiv.org/abs/1807.04975}{recognize a cow standing on a beach}?
\end{enumerate}